<?php
/*--------------------------------------------------------------------------------------------------
    OnGetSellingUnitReservedQuantityEventInterface.php 2020-07-08
    Gambio GmbH
    http://www.gambio.de
    Copyright (c) 2020 Gambio GmbH
    Released under the GNU General Public License (Version 2)
    [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Shop\SellingUnit\Database\Unit\Events\Interfaces;


use Gambio\Shop\SellingUnit\Unit\ValueObjects\Interfaces\QuantityInterface;
use Gambio\Shop\SellingUnit\Unit\ValueObjects\ReservedQuantity;
use Gambio\Shop\SellingUnit\Unit\ValueObjects\SellingUnitId;
use Psr\EventDispatcher\StoppableEventInterface;

/**
 * interface GetProductReservedQuantityEventInterface
 */
interface OnGetSellingUnitReservedQuantityEventInterface extends StoppableEventInterface
{
    /**
     * @return SellingUnitId
     */
    public function id(): SellingUnitId;

    /**
     * @return ReservedQuantity|null
     */
    public function quantity(): ?ReservedQuantity;

    /**
     * @param ReservedQuantity $reservedQuantity
     */
    public function setQuantity(ReservedQuantity $reservedQuantity): void;

    /**
     * @return QuantityInterface
     */
    public function requested(): QuantityInterface;

    /**
     * Stop the event propagation
     */
    public function stop(): void;

}